' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' CheckDirectDerivation - written by Kevin Hardy
' This module checks a functional dependency set for direct derivation.

Public Class CheckDirectDerivation
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Private FunctionalDependencies As ArrayList
 Private Attributes As ArrayList
 Private x As Integer
 Private y As Integer

 Private Sub CheckDirectDerivation_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  Location = New Point(x, y)
 End Sub

#Region " Windows Form Designer generated code "

 Public Sub New(ByVal Attributes As ArrayList, ByVal FunctionalDependencies As ArrayList, ByVal x As Integer, ByVal y As Integer)
  MyBase.New()
  InitializeComponent()
  Me.x = x
  Me.y = y
  Me.Attributes = Attributes
  For Each Attribute As String In Attributes
   lstLeftHandSide.Items.Add(Attribute)
   lstRightHandSide.Items.Add(Attribute)
  Next
  Me.FunctionalDependencies = FunctionalDependencies
  For Each FD As FunctionalDependency In FunctionalDependencies
   Dim strFD As String = ""
   For Each Attribute As Integer In FD.LeftHandSide
    strFD = strFD + Attributes(Attribute) + " "
   Next
   strFD = strFD + "-> "
   For Each Attribute As Integer In FD.RightHandSide
    strFD = strFD + Attributes(Attribute) + " "
   Next
   lstFunctionalDependencies.Items.Add(strFD)
  Next
 End Sub
 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents Label1 As System.Windows.Forms.Label
 Friend WithEvents Label2 As System.Windows.Forms.Label
 Friend WithEvents lstLeftHandSide As System.Windows.Forms.ListBox
 Friend WithEvents lstRightHandSide As System.Windows.Forms.ListBox
 Friend WithEvents btnTest As System.Windows.Forms.Button
 Friend WithEvents Label3 As System.Windows.Forms.Label
 Friend WithEvents Label4 As System.Windows.Forms.Label
 Friend WithEvents lstFunctionalDependencies As System.Windows.Forms.ListBox
 Friend WithEvents txtResult As System.Windows.Forms.TextBox
 Friend WithEvents btnOK As System.Windows.Forms.Button
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(CheckDirectDerivation))
  Me.btnTest = New System.Windows.Forms.Button
  Me.lstLeftHandSide = New System.Windows.Forms.ListBox
  Me.lstRightHandSide = New System.Windows.Forms.ListBox
  Me.Label1 = New System.Windows.Forms.Label
  Me.Label2 = New System.Windows.Forms.Label
  Me.Label3 = New System.Windows.Forms.Label
  Me.Label4 = New System.Windows.Forms.Label
  Me.lstFunctionalDependencies = New System.Windows.Forms.ListBox
  Me.txtResult = New System.Windows.Forms.TextBox
  Me.btnOK = New System.Windows.Forms.Button
  Me.SuspendLayout()
  '
  'btnTest
  '
  Me.btnTest.Location = New System.Drawing.Point(8, 352)
  Me.btnTest.Name = "btnTest"
  Me.btnTest.Size = New System.Drawing.Size(152, 23)
  Me.btnTest.TabIndex = 2
  Me.btnTest.Text = "Test for Direct Derivation"
  '
  'lstLeftHandSide
  '
  Me.lstLeftHandSide.Location = New System.Drawing.Point(8, 56)
  Me.lstLeftHandSide.Name = "lstLeftHandSide"
  Me.lstLeftHandSide.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple
  Me.lstLeftHandSide.Size = New System.Drawing.Size(120, 108)
  Me.lstLeftHandSide.TabIndex = 0
  '
  'lstRightHandSide
  '
  Me.lstRightHandSide.Location = New System.Drawing.Point(136, 56)
  Me.lstRightHandSide.Name = "lstRightHandSide"
  Me.lstRightHandSide.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple
  Me.lstRightHandSide.Size = New System.Drawing.Size(120, 108)
  Me.lstRightHandSide.TabIndex = 1
  '
  'Label1
  '
  Me.Label1.Location = New System.Drawing.Point(8, 32)
  Me.Label1.Name = "Label1"
  Me.Label1.Size = New System.Drawing.Size(120, 23)
  Me.Label1.TabIndex = 8
  Me.Label1.Text = "Left-Hand Side"
  Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'Label2
  '
  Me.Label2.Location = New System.Drawing.Point(136, 32)
  Me.Label2.Name = "Label2"
  Me.Label2.Size = New System.Drawing.Size(120, 23)
  Me.Label2.TabIndex = 9
  Me.Label2.Text = "Right-Hand Side"
  Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'Label3
  '
  Me.Label3.Location = New System.Drawing.Point(60, 8)
  Me.Label3.Name = "Label3"
  Me.Label3.Size = New System.Drawing.Size(144, 23)
  Me.Label3.TabIndex = 10
  Me.Label3.Text = "Choose Attributes to Test"
  Me.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'Label4
  '
  Me.Label4.Location = New System.Drawing.Point(8, 176)
  Me.Label4.Name = "Label4"
  Me.Label4.Size = New System.Drawing.Size(248, 24)
  Me.Label4.TabIndex = 11
  Me.Label4.Text = "Or Select an Existing Functional Dependency"
  Me.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'lstFunctionalDependencies
  '
  Me.lstFunctionalDependencies.Location = New System.Drawing.Point(8, 200)
  Me.lstFunctionalDependencies.Name = "lstFunctionalDependencies"
  Me.lstFunctionalDependencies.Size = New System.Drawing.Size(248, 134)
  Me.lstFunctionalDependencies.TabIndex = 12
  '
  'txtResult
  '
  Me.txtResult.Location = New System.Drawing.Point(8, 392)
  Me.txtResult.Multiline = True
  Me.txtResult.Name = "txtResult"
  Me.txtResult.ReadOnly = True
  Me.txtResult.Size = New System.Drawing.Size(248, 48)
  Me.txtResult.TabIndex = 14
  Me.txtResult.Text = "Result:"
  '
  'btnOK
  '
  Me.btnOK.Location = New System.Drawing.Point(168, 352)
  Me.btnOK.Name = "btnOK"
  Me.btnOK.Size = New System.Drawing.Size(88, 23)
  Me.btnOK.TabIndex = 15
  Me.btnOK.Text = "OK"
  '
  'CheckDirectDerivation
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(262, 444)
  Me.Controls.Add(Me.btnOK)
  Me.Controls.Add(Me.txtResult)
  Me.Controls.Add(Me.lstFunctionalDependencies)
  Me.Controls.Add(Me.Label4)
  Me.Controls.Add(Me.Label3)
  Me.Controls.Add(Me.Label2)
  Me.Controls.Add(Me.Label1)
  Me.Controls.Add(Me.lstRightHandSide)
  Me.Controls.Add(Me.lstLeftHandSide)
  Me.Controls.Add(Me.btnTest)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.MaximizeBox = False
  Me.MinimizeBox = False
  Me.Name = "CheckDirectDerivation"
  Me.ShowInTaskbar = False
  Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide
  Me.Text = "Check Direct Derivation"
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub lstFunctionalDependencies_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstFunctionalDependencies.SelectedIndexChanged
  If lstFunctionalDependencies.SelectedIndices.Count = 1 Then
   Dim SelectedFD As FunctionalDependency = FunctionalDependencies(lstFunctionalDependencies.SelectedIndices(0))
   lstLeftHandSide.ClearSelected()
   For Each Attribute As Integer In SelectedFD.LeftHandSide
    lstLeftHandSide.SetSelected(Attribute, True)
   Next
   lstLeftHandSide.Refresh()
   lstRightHandSide.ClearSelected()
   For Each Attribute As Integer In SelectedFD.RightHandSide
    lstRightHandSide.SetSelected(Attribute, True)
   Next
   lstRightHandSide.Refresh()
  End If
 End Sub

 Private Sub btnTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTest.Click
  Dim FD As New FunctionalDependency
  Dim strLeftHandSide As String = ""
  For Attribute As Integer = 0 To lstLeftHandSide.Items.Count - 1
   If lstLeftHandSide.GetSelected(Attribute) = True Then
    FD.LeftHandSide.Add(Attribute)
    If strLeftHandSide.Length > 0 Then
     strLeftHandSide += " " + Attributes(Attribute)
    Else
     strLeftHandSide = Attributes(Attribute)
    End If
   End If
  Next
  Dim strRightHandSide As String = ""
  For Attribute As Integer = 0 To lstRightHandSide.Items.Count - 1
   If lstRightHandSide.GetSelected(Attribute) = True Then
    FD.RightHandSide.Add(Attribute)
    If strRightHandSide.Length > 0 Then
     strRightHandSide += " " + Attributes(Attribute)
    Else
     strRightHandSide = Attributes(Attribute)
    End If
   End If
  Next
  Dim d As New DirectDerives
  Dim strResult As String = "Result: {" + strLeftHandSide
  If d.directDerives(Attributes, FunctionalDependencies, FD) Then
   strResult += "} directly derives {"
  Else
   strResult += "} does not directly derive {"
  End If
  strResult += strRightHandSide + "}."
  txtResult.Text = strResult
  txtResult.Refresh()
 End Sub

 Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
  Close()
 End Sub

#End Region

End Class

Public Class DirectDerives

#Region "Core functions"

 Public Function directDerives(ByVal UniversalAttributeSet As ArrayList, ByVal FDSet As ArrayList, ByVal singleFDthatDDs As FunctionalDependency) As Boolean
  Dim i, j, k As Integer
  Dim isDD As Boolean
  Dim countX, countLHS, countRHS As Integer
  Dim LinClosureX As New LinClosure
  Dim LinClosureLHS As New LinClosure
  Dim NonredundantObject As New CheckRedundancyObject
  Dim nonredundantFDset As New ArrayList
  Dim nonredundantFD As New FunctionalDependency

  nonredundantFDset = NonredundantObject.Nonredundant(UniversalAttributeSet, FDSet)
  Dim XClosure As ArrayList = LinClosureX.ComputeLinClosure(UniversalAttributeSet, singleFDthatDDs.LeftHandSide, nonredundantFDset)

  k = 0
  While k < nonredundantFDset.Count
   nonredundantFD = nonredundantFDset(k)
   countX = 0
   countLHS = 0
   Dim LHSClosure As ArrayList = LinClosureLHS.ComputeLinClosure(UniversalAttributeSet, nonredundantFD.LeftHandSide, nonredundantFDset)

   For i = 0 To XClosure.Count - 1
    For j = 0 To nonredundantFD.LeftHandSide.Count - 1
     If (XClosure(i) = nonredundantFD.LeftHandSide(j)) Then
      countX = countX + 1
     End If
    Next
   Next
   For i = 0 To LHSClosure.Count - 1
    For j = 0 To singleFDthatDDs.LeftHandSide.Count - 1
     If (LHSClosure(i) = singleFDthatDDs.LeftHandSide(j)) Then
      countLHS = countLHS + 1
     End If
    Next
   Next
   If (countX = nonredundantFD.LeftHandSide.Count And countLHS = singleFDthatDDs.LeftHandSide.Count) Then
    nonredundantFDset.RemoveAt(k)
   Else
    k = k + 1
   End If
  End While
  countLHS = 0
  Dim EsubNonredundantFDsetOfLHSClosure As ArrayList = LinClosureLHS.ComputeLinClosure(UniversalAttributeSet, singleFDthatDDs.LeftHandSide, nonredundantFDset)
  For i = 0 To EsubNonredundantFDsetOfLHSClosure.Count - 1
   For j = 0 To singleFDthatDDs.RightHandSide.Count - 1
    If (EsubNonredundantFDsetOfLHSClosure(i) = singleFDthatDDs.RightHandSide(j)) Then
     countRHS = countRHS + 1
    End If
   Next
  Next
  If singleFDthatDDs.RightHandSide.Count = countRHS Then
   isDD = True
  Else
   isDD = False
  End If
  Return isDD
 End Function
 'finds all X<-->LHS
 Public Function EsubFofX(ByVal UniversalAttributeSet As ArrayList, ByVal FDSet As ArrayList, ByVal singleFD As FunctionalDependency) As ArrayList
  Dim i, j, k As Integer
  Dim countX, countLHS, countRHS As Integer
  Dim LinClosureX As New LinClosure
  Dim LinClosureLHS As New LinClosure
  Dim NonredundantObject As New CheckRedundancyObject
  Dim nonredundantFDset As New ArrayList
  Dim nonredundantFD As New FunctionalDependency
  Dim EsubF As New ArrayList
  Dim EsubFFD As New FunctionalDependency

  nonredundantFDset = NonredundantObject.Nonredundant(UniversalAttributeSet, FDSet)
  Dim XClosure As ArrayList = LinClosureX.ComputeLinClosure(UniversalAttributeSet, singleFD.LeftHandSide, nonredundantFDset)

  k = 0
  While k < nonredundantFDset.Count
   nonredundantFD = nonredundantFDset(k)
   EsubFFD = nonredundantFDset(k)
   countX = 0
   countLHS = 0
   Dim LHSClosure As ArrayList = LinClosureLHS.ComputeLinClosure(UniversalAttributeSet, nonredundantFD.LeftHandSide, nonredundantFDset)

   For i = 0 To XClosure.Count - 1
    For j = 0 To nonredundantFD.LeftHandSide.Count - 1
     If (XClosure(i) = nonredundantFD.LeftHandSide(j)) Then
      countX = countX + 1
     End If
    Next
   Next
   For i = 0 To LHSClosure.Count - 1
    For j = 0 To singleFD.LeftHandSide.Count - 1
     If (LHSClosure(i) = singleFD.LeftHandSide(j)) Then
      countLHS = countLHS + 1
     End If
    Next
   Next
   If (countX = nonredundantFD.LeftHandSide.Count And countLHS = singleFD.LeftHandSide.Count) Then
    nonredundantFDset.RemoveAt(k)
    EsubF.Add(EsubFFD)
   Else
    k = k + 1
   End If
  End While
  'Dim a As New AttributeAndFDSetDetails(UniversalAttributeSet, EsubF)
  'a.ShowDialog()
  Return EsubF
 End Function
 'finds all R - X<-->LHS
 Public Function RminusEsubFofX(ByVal UniversalAttributeSet As ArrayList, ByVal FDSet As ArrayList, ByVal singleFD As FunctionalDependency) As ArrayList
  Dim i, j, k As Integer
  Dim countX, countLHS, countRHS As Integer
  Dim LinClosureX As New LinClosure
  Dim LinClosureLHS As New LinClosure
  Dim NonredundantObject As New CheckRedundancyObject
  Dim nonredundantFDset As New ArrayList
  Dim nonredundantFD As New FunctionalDependency
  Dim EsubF As New ArrayList
  Dim EsubFFD As New FunctionalDependency

  nonredundantFDset = NonredundantObject.Nonredundant(UniversalAttributeSet, FDSet)
  Dim XClosure As ArrayList = LinClosureX.ComputeLinClosure(UniversalAttributeSet, singleFD.LeftHandSide, nonredundantFDset)

  k = 0
  While k < nonredundantFDset.Count
   nonredundantFD = nonredundantFDset(k)
   EsubFFD = nonredundantFDset(k)
   countX = 0
   countLHS = 0
   Dim LHSClosure As ArrayList = LinClosureLHS.ComputeLinClosure(UniversalAttributeSet, nonredundantFD.LeftHandSide, nonredundantFDset)

   For i = 0 To XClosure.Count - 1
    For j = 0 To nonredundantFD.LeftHandSide.Count - 1
     If (XClosure(i) = nonredundantFD.LeftHandSide(j)) Then
      countX = countX + 1
     End If
    Next
   Next
   For i = 0 To LHSClosure.Count - 1
    For j = 0 To singleFD.LeftHandSide.Count - 1
     If (LHSClosure(i) = singleFD.LeftHandSide(j)) Then
      countLHS = countLHS + 1
     End If
    Next
   Next
   If (countX = nonredundantFD.LeftHandSide.Count And countLHS = singleFD.LeftHandSide.Count) Then
    nonredundantFDset.RemoveAt(k)
    EsubF.Add(EsubFFD)
   Else
    k = k + 1
   End If
  End While
  Dim a As New AttributeAndFDSetDetails(UniversalAttributeSet, EsubF)
  a.ShowDialog()
  Return nonredundantFDset
 End Function

#End Region

End Class
