' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' CheckMinimum - written by Kevin Hardy
' This module checks a functional dependency set for minimality.

Public Class CheckMinimum
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Private Attributes As ArrayList
 Private FunctionalDependencies As ArrayList
 Private MinimumFunctionalDependencies As ArrayList
 Public ReturnedFunctionalDependencies As ArrayList
 Private x As Integer
 Private y As Integer

 Private Sub CheckMinimum_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  Location = New Point(x, y)
 End Sub

#Region " Windows Form Designer generated code "

 Public Sub New(ByVal Attributes As ArrayList, ByVal FunctionalDependencies As ArrayList, ByVal x As Integer, ByVal y As Integer)
  MyBase.New()
  InitializeComponent()
  Me.x = x
  Me.y = y
  Me.Attributes = Attributes
  Me.FunctionalDependencies = FunctionalDependencies
  ReturnedFunctionalDependencies = FunctionalDependencies
  ' Fill original FD set list
  For Each FD As FunctionalDependency In FunctionalDependencies
   Dim strFD As String = ""
   For Each Attribute As Integer In FD.LeftHandSide
    strFD += Attributes(Attribute) + " "
   Next
   strFD += "-> "
   For Each Attribute As Integer In FD.RightHandSide
    strFD += Attributes(Attribute) + " "
   Next
   lstOriginalFDs.Items.Add(strFD)
  Next
  Dim m As New Minimize
  MinimumFunctionalDependencies = m.minimize(Attributes, FunctionalDependencies)
  ' Fill original FD set list
  For Each FD As FunctionalDependency In MinimumFunctionalDependencies
   Dim strFD As String = ""
   For Each Attribute As Integer In FD.LeftHandSide
    strFD += Attributes(Attribute) + " "
   Next
   strFD += "-> "
   For Each Attribute As Integer In FD.RightHandSide
    strFD += Attributes(Attribute) + " "
   Next
   Me.lstMinimumFDs.Items.Add(strFD)
  Next
 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents lbl2NF As System.Windows.Forms.Label
 Friend WithEvents btnOK As System.Windows.Forms.Button
 Friend WithEvents lstMinimumFDs As System.Windows.Forms.ListBox
 Friend WithEvents lstOriginalFDs As System.Windows.Forms.ListBox
 Friend WithEvents Label1 As System.Windows.Forms.Label
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(CheckMinimum))
  Me.lbl2NF = New System.Windows.Forms.Label
  Me.btnOK = New System.Windows.Forms.Button
  Me.lstMinimumFDs = New System.Windows.Forms.ListBox
  Me.lstOriginalFDs = New System.Windows.Forms.ListBox
  Me.Label1 = New System.Windows.Forms.Label
  Me.SuspendLayout()
  '
  'lbl2NF
  '
  Me.lbl2NF.Location = New System.Drawing.Point(8, 216)
  Me.lbl2NF.Name = "lbl2NF"
  Me.lbl2NF.Size = New System.Drawing.Size(224, 21)
  Me.lbl2NF.TabIndex = 2
  Me.lbl2NF.Text = "Minimum Cover For This FD Set:"
  Me.lbl2NF.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'btnOK
  '
  Me.btnOK.Location = New System.Drawing.Point(81, 416)
  Me.btnOK.Name = "btnOK"
  Me.btnOK.Size = New System.Drawing.Size(80, 24)
  Me.btnOK.TabIndex = 3
  Me.btnOK.Text = "OK"
  '
  'lstMinimumFDs
  '
  Me.lstMinimumFDs.Location = New System.Drawing.Point(8, 240)
  Me.lstMinimumFDs.Name = "lstMinimumFDs"
  Me.lstMinimumFDs.Size = New System.Drawing.Size(224, 160)
  Me.lstMinimumFDs.TabIndex = 4
  '
  'lstOriginalFDs
  '
  Me.lstOriginalFDs.Location = New System.Drawing.Point(8, 40)
  Me.lstOriginalFDs.Name = "lstOriginalFDs"
  Me.lstOriginalFDs.Size = New System.Drawing.Size(224, 160)
  Me.lstOriginalFDs.TabIndex = 5
  '
  'Label1
  '
  Me.Label1.Location = New System.Drawing.Point(8, 8)
  Me.Label1.Name = "Label1"
  Me.Label1.Size = New System.Drawing.Size(224, 21)
  Me.Label1.TabIndex = 6
  Me.Label1.Text = "Original FD Set:"
  Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'CheckMinimum
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(238, 444)
  Me.Controls.Add(Me.Label1)
  Me.Controls.Add(Me.lstOriginalFDs)
  Me.Controls.Add(Me.lstMinimumFDs)
  Me.Controls.Add(Me.btnOK)
  Me.Controls.Add(Me.lbl2NF)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.MaximizeBox = False
  Me.MinimizeBox = False
  Me.Name = "CheckMinimum"
  Me.Text = "Check Redundancy"
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
  Dim SameSet As Boolean = True
  For Each FD1 As FunctionalDependency In FunctionalDependencies
   Dim FoundFD As Boolean = False
   For Each FD2 As FunctionalDependency In MinimumFunctionalDependencies
    Dim SameFD As Boolean = True
    For Each Attribute1 As Integer In FD1.LeftHandSide
     Dim FoundAttribute As Boolean = False
     For Each Attribute2 As Integer In FD2.LeftHandSide
      If Attribute1 = Attribute2 Then
       FoundAttribute = True
      End If
     Next
     If FoundAttribute = False Then
      SameFD = False
     End If
    Next
    For Each Attribute1 As Integer In FD1.RightHandSide
     Dim FoundAttribute As Boolean = False
     For Each Attribute2 As Integer In FD2.RightHandSide
      If Attribute1 = Attribute2 Then
       FoundAttribute = True
      End If
     Next
     If FoundAttribute = False Then
      SameFD = False
     End If
    Next
    If SameFD = True Then
     FoundFD = True
    End If
   Next
   If FoundFD = False Then
    SameSet = False
   End If
  Next
  If SameSet = False Then
   If MessageBox.Show("Adopt minimum FD set? (This will modify your current FD set.)", "", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
    ReturnedFunctionalDependencies = MinimumFunctionalDependencies
   End If
  End If
  Me.Close()
 End Sub

#End Region

End Class

Public Class Minimize

#Region "Core functions"

 Public Function minimize(ByVal UniversalAttributeSet As ArrayList, ByVal FDSet As ArrayList) As ArrayList
  Dim NonredundantObject As New CheckRedundancyObject
  Dim F As New ArrayList
  Dim RlessEsubF As New ArrayList
  Dim G As New ArrayList
  Dim H As New ArrayList
  Dim H2 As New ArrayList
  Dim singleFD As FunctionalDependency
  Dim DDFD1 As FunctionalDependency
  Dim DDFD2 As FunctionalDependency
  Dim i, j, k As Integer
  Dim EsubFofXObject As New DirectDerives
  Dim DirectDerivesObject As New DirectDerives
  Dim startingFCount As Integer
  For Each FD As FunctionalDependency In FDSet
   G.Add(FD)
  Next

  F = NonredundantObject.Nonredundant(UniversalAttributeSet, G)
  For Each FD As FunctionalDependency In F
   H.Add(FD)
   H2.Add(FD)
  Next

  k = 0
  startingFCount = F.Count
  While k < startingFCount
   singleFD = F(0)
   Dim EsubF As ArrayList = EsubFofXObject.EsubFofX(UniversalAttributeSet, H2, singleFD)
   For Each FD As FunctionalDependency In EsubF
    F.Remove(FD)
   Next

   k = k + EsubF.Count
   For i = 0 To EsubF.Count - 1
    For j = 0 To EsubF.Count - 1
     If i < j - 1 Then
      Dim DirectDeriveFD As New FunctionalDependency
      Dim YU As FunctionalDependency = EsubF(i)
      For Each Attribute As Integer In YU.LeftHandSide
       DirectDeriveFD.LeftHandSide.Add(Attribute)
      Next
      Dim ZV As FunctionalDependency = EsubF(j)
      For Each Attribute As Integer In ZV.LeftHandSide
       DirectDeriveFD.RightHandSide.Add(Attribute)
      Next

      If EsubFofXObject.directDerives(UniversalAttributeSet, H2, DirectDeriveFD) = True Then
       Dim ZUV As New FunctionalDependency
       For Each Attribute As Integer In ZV.LeftHandSide
        ZUV.LeftHandSide.Add(Attribute)
       Next
       For Each Attribute As Integer In YU.RightHandSide
        ZUV.RightHandSide.Add(Attribute)
       Next
       For Each Attribute As Integer In ZV.RightHandSide
        ZUV.RightHandSide.Add(Attribute)
       Next
       EsubF.Remove(YU)
       EsubF.Remove(ZV)
       EsubF.Add(ZUV)
       H.Remove(YU)
       H.Remove(ZV)
       H.Add(ZUV)
      End If
     End If
    Next
   Next
  End While
  Return H
 End Function

#End Region

End Class
