' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' AddEditFDSet - written by David J. Stein, Esq.
' This module allows the user to add or edit a functional dependency set.

Public Class AddEditFDSet
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Private InitialFDSet As FunctionalDependency

 Private Sub AddEditFDSet_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  If Not (InitialFDSet Is Nothing) Then
   For Each LHSItem As Integer In InitialFDSet.LeftHandSide
    lstLeftHandSide.SetSelected(LHSItem, True)
   Next
   lstLeftHandSide.Refresh()
   For Each RHSItem As Integer In InitialFDSet.RightHandSide
    lstRightHandSide.SetSelected(RHSItem, True)
   Next
   lstRightHandSide.Refresh()
  End If
 End Sub

#Region " Windows Form Designer generated code "

 Public Sub New(ByVal Attributes As ArrayList)
  MyBase.New()
  InitializeComponent()
  For Each Attribute As String In Attributes
   lstLeftHandSide.Items.Add(Attribute)
   lstRightHandSide.Items.Add(Attribute)
  Next
  InitialFDSet = Nothing
 End Sub
 Public Sub New(ByVal Attributes As ArrayList, ByVal FD As FunctionalDependency)
  MyBase.New()
  InitializeComponent()
  For Each Attribute As String In Attributes
   lstLeftHandSide.Items.Add(Attribute)
   lstRightHandSide.Items.Add(Attribute)
  Next
  InitialFDSet = FD
 End Sub
 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents Label1 As System.Windows.Forms.Label
 Friend WithEvents Label2 As System.Windows.Forms.Label
 Friend WithEvents btnCancel As System.Windows.Forms.Button
 Friend WithEvents btnSave As System.Windows.Forms.Button
 Friend WithEvents lstLeftHandSide As System.Windows.Forms.ListBox
 Friend WithEvents lstRightHandSide As System.Windows.Forms.ListBox
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(AddEditFDSet))
  Me.btnCancel = New System.Windows.Forms.Button
  Me.btnSave = New System.Windows.Forms.Button
  Me.lstLeftHandSide = New System.Windows.Forms.ListBox
  Me.lstRightHandSide = New System.Windows.Forms.ListBox
  Me.Label1 = New System.Windows.Forms.Label
  Me.Label2 = New System.Windows.Forms.Label
  Me.SuspendLayout()
  '
  'btnCancel
  '
  Me.btnCancel.Location = New System.Drawing.Point(136, 200)
  Me.btnCancel.Name = "btnCancel"
  Me.btnCancel.Size = New System.Drawing.Size(120, 23)
  Me.btnCancel.TabIndex = 3
  Me.btnCancel.Text = "Cancel"
  '
  'btnSave
  '
  Me.btnSave.Location = New System.Drawing.Point(8, 200)
  Me.btnSave.Name = "btnSave"
  Me.btnSave.Size = New System.Drawing.Size(120, 23)
  Me.btnSave.TabIndex = 2
  Me.btnSave.Text = "Save"
  '
  'lstLeftHandSide
  '
  Me.lstLeftHandSide.Location = New System.Drawing.Point(8, 32)
  Me.lstLeftHandSide.Name = "lstLeftHandSide"
  Me.lstLeftHandSide.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple
  Me.lstLeftHandSide.Size = New System.Drawing.Size(120, 160)
  Me.lstLeftHandSide.TabIndex = 0
  '
  'lstRightHandSide
  '
  Me.lstRightHandSide.Location = New System.Drawing.Point(136, 32)
  Me.lstRightHandSide.Name = "lstRightHandSide"
  Me.lstRightHandSide.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple
  Me.lstRightHandSide.Size = New System.Drawing.Size(120, 160)
  Me.lstRightHandSide.TabIndex = 1
  '
  'Label1
  '
  Me.Label1.Location = New System.Drawing.Point(8, 8)
  Me.Label1.Name = "Label1"
  Me.Label1.Size = New System.Drawing.Size(120, 23)
  Me.Label1.TabIndex = 8
  Me.Label1.Text = "Left-Hand Side"
  Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'Label2
  '
  Me.Label2.Location = New System.Drawing.Point(136, 8)
  Me.Label2.Name = "Label2"
  Me.Label2.Size = New System.Drawing.Size(120, 23)
  Me.Label2.TabIndex = 9
  Me.Label2.Text = "Right-Hand Side"
  Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'AddEditFDSet
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(264, 230)
  Me.Controls.Add(Me.Label2)
  Me.Controls.Add(Me.Label1)
  Me.Controls.Add(Me.lstRightHandSide)
  Me.Controls.Add(Me.lstLeftHandSide)
  Me.Controls.Add(Me.btnCancel)
  Me.Controls.Add(Me.btnSave)
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.MaximizeBox = False
  Me.MinimizeBox = False
  Me.Name = "AddEditFDSet"
  Me.ShowInTaskbar = False
  Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide
  Me.Text = "Functional Dependency Details"
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
  DialogResult = DialogResult.OK
  Close()
 End Sub

 Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
  DialogResult = DialogResult.Cancel
  Close()
 End Sub

#End Region

End Class
