' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' FindLinClosure - written by David J. Stein, Esq.
' This module finds the closure of a functional dependency set via the LinClosure algorithm.

Public Class FindLinClosure
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Dim UniversalAttributeSet As ArrayList
 Dim FDSet As ArrayList
 Private x As Integer
 Private y As Integer

 Private Sub FindLinClosure_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  Location = New Point(x, y)
  For Each Attribute As String In UniversalAttributeSet
   lstSelectedAttributes.Items.Add(Attribute)
  Next
  Dim BasePath As String = System.Reflection.Assembly.GetExecutingAssembly().Location
  BasePath = BasePath.Substring(0, BasePath.Length - 37)
  Dim DirectoryPath As String = BasePath + "$AN"
  If System.IO.File.Exists(DirectoryPath) Then
   Dim input As New System.IO.StreamReader(DirectoryPath)
   Dim fullinput As String = input.ReadToEnd()
   input.Close()
   Dim filenames As String() = fullinput.Split(vbCrLf)
   lstAttributeSets.BeginUpdate()
   lstAttributeSets.Items.Clear()
   For Each filename As String In filenames
    Dim trimmedfilename As String = filename.Trim()
    If trimmedfilename.Length > 0 And System.IO.File.Exists(BasePath + "$A_" + trimmedfilename) Then
     lstAttributeSets.Items.Add(trimmedfilename)
    End If
   Next
   lstAttributeSets.EndUpdate()
   lstAttributeSets.Refresh()
  End If
 End Sub
 Private Sub lstSelectedAttributes_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstSelectedAttributes.SelectedIndexChanged
  lstResultsLHS.BeginUpdate()
  lstResultsLHS.Items.Clear()
  For i As Integer = 0 To lstSelectedAttributes.Items.Count - 1
   If lstSelectedAttributes.GetSelected(i) = True Then
    lstResultsLHS.Items.Add(lstSelectedAttributes.Items(i))
   End If
  Next
  lstResultsLHS.EndUpdate()
  lstResultsLHS.Refresh()
  ' Refresh RHS so we don't get the wrong idea here
  lstResultsRHS.Items.Clear()
  lstResultsRHS.Refresh()
 End Sub

#Region " Windows Form Designer generated code "

 Public Sub New(ByRef UniversalAttributeSet As ArrayList, ByRef FDSet As ArrayList, ByVal x As Integer, ByVal y As Integer)
  MyBase.New()
  InitializeComponent()
  Me.x = x
  Me.y = y
  Me.UniversalAttributeSet = UniversalAttributeSet
  Me.FDSet = FDSet
 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents Label1 As System.Windows.Forms.Label
 Friend WithEvents lstSelectedAttributes As System.Windows.Forms.ListBox
 Friend WithEvents Label2 As System.Windows.Forms.Label
 Friend WithEvents lstAttributeSets As System.Windows.Forms.ListBox
 Friend WithEvents lstResultsLHS As System.Windows.Forms.ListBox
 Friend WithEvents lstResultsRHS As System.Windows.Forms.ListBox
 Friend WithEvents Label3 As System.Windows.Forms.Label
 Friend WithEvents btnLinClosureSelectedAttributes As System.Windows.Forms.Button
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(FindLinClosure))
  Me.Label1 = New System.Windows.Forms.Label
  Me.lstSelectedAttributes = New System.Windows.Forms.ListBox
  Me.btnLinClosureSelectedAttributes = New System.Windows.Forms.Button
  Me.Label2 = New System.Windows.Forms.Label
  Me.lstAttributeSets = New System.Windows.Forms.ListBox
  Me.lstResultsLHS = New System.Windows.Forms.ListBox
  Me.lstResultsRHS = New System.Windows.Forms.ListBox
  Me.Label3 = New System.Windows.Forms.Label
  Me.SuspendLayout()
  '
  'Label1
  '
  Me.Label1.Location = New System.Drawing.Point(12, 8)
  Me.Label1.Name = "Label1"
  Me.Label1.Size = New System.Drawing.Size(120, 32)
  Me.Label1.TabIndex = 0
  Me.Label1.Text = "Select Attributes From Current Attribute Set:"
  Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'lstSelectedAttributes
  '
  Me.lstSelectedAttributes.Location = New System.Drawing.Point(16, 40)
  Me.lstSelectedAttributes.Name = "lstSelectedAttributes"
  Me.lstSelectedAttributes.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple
  Me.lstSelectedAttributes.Size = New System.Drawing.Size(112, 173)
  Me.lstSelectedAttributes.TabIndex = 0
  '
  'btnLinClosureSelectedAttributes
  '
  Me.btnLinClosureSelectedAttributes.Location = New System.Drawing.Point(32, 224)
  Me.btnLinClosureSelectedAttributes.Name = "btnLinClosureSelectedAttributes"
  Me.btnLinClosureSelectedAttributes.Size = New System.Drawing.Size(208, 23)
  Me.btnLinClosureSelectedAttributes.TabIndex = 2
  Me.btnLinClosureSelectedAttributes.Text = "Find Lin Closure of Selected Attributes"
  '
  'Label2
  '
  Me.Label2.Location = New System.Drawing.Point(144, 8)
  Me.Label2.Name = "Label2"
  Me.Label2.Size = New System.Drawing.Size(112, 32)
  Me.Label2.TabIndex = 3
  Me.Label2.Text = "Or Double-Click a Known Attribute Set:"
  Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'lstAttributeSets
  '
  Me.lstAttributeSets.Location = New System.Drawing.Point(144, 40)
  Me.lstAttributeSets.Name = "lstAttributeSets"
  Me.lstAttributeSets.Size = New System.Drawing.Size(112, 173)
  Me.lstAttributeSets.TabIndex = 1
  '
  'lstResultsLHS
  '
  Me.lstResultsLHS.Location = New System.Drawing.Point(16, 280)
  Me.lstResultsLHS.Name = "lstResultsLHS"
  Me.lstResultsLHS.SelectionMode = System.Windows.Forms.SelectionMode.None
  Me.lstResultsLHS.Size = New System.Drawing.Size(112, 160)
  Me.lstResultsLHS.TabIndex = 3
  '
  'lstResultsRHS
  '
  Me.lstResultsRHS.Location = New System.Drawing.Point(144, 280)
  Me.lstResultsRHS.Name = "lstResultsRHS"
  Me.lstResultsRHS.SelectionMode = System.Windows.Forms.SelectionMode.None
  Me.lstResultsRHS.Size = New System.Drawing.Size(112, 160)
  Me.lstResultsRHS.TabIndex = 4
  '
  'Label3
  '
  Me.Label3.Location = New System.Drawing.Point(16, 256)
  Me.Label3.Name = "Label3"
  Me.Label3.Size = New System.Drawing.Size(240, 23)
  Me.Label3.TabIndex = 8
  Me.Label3.Text = "Results: LHS Attributes -> RHS Attributes"
  Me.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'FindLinClosure
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(272, 448)
  Me.Controls.Add(Me.Label3)
  Me.Controls.Add(Me.lstAttributeSets)
  Me.Controls.Add(Me.Label2)
  Me.Controls.Add(Me.btnLinClosureSelectedAttributes)
  Me.Controls.Add(Me.lstSelectedAttributes)
  Me.Controls.Add(Me.Label1)
  Me.Controls.Add(Me.lstResultsRHS)
  Me.Controls.Add(Me.lstResultsLHS)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.MaximizeBox = False
  Me.MinimizeBox = False
  Me.Name = "FindLinClosure"
  Me.ShowInTaskbar = False
  Me.Text = "Find Direct Derivation"
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub btnLinClosureSelectedAttributes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLinClosureSelectedAttributes.Click
  ' Construct selected array list to pass to LinClosure function
  Dim ClosureAttributeSet As New ArrayList
  For i As Integer = 0 To lstSelectedAttributes.Items.Count - 1
   If lstSelectedAttributes.GetSelected(i) = True Then
    ClosureAttributeSet.Add(i)
   End If
  Next
  Dim LinClosureObject As New LinClosure
  Dim RHS As ArrayList = LinClosureObject.ComputeLinClosure(UniversalAttributeSet, ClosureAttributeSet, FDSet)
  ' Update RHS List
  lstResultsRHS.BeginUpdate()
  lstResultsRHS.Items.Clear()
  For Each RHSItem As Integer In RHS
   lstResultsRHS.Items.Add(UniversalAttributeSet(RHSItem))
  Next
  lstResultsRHS.EndUpdate()
  lstResultsRHS.Refresh()
 End Sub

 Private Sub lstAttributeSets_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstAttributeSets.DoubleClick
  If lstAttributeSets.SelectedIndex <> -1 Then
   Dim BasePath As String = System.Reflection.Assembly.GetExecutingAssembly().Location
   BasePath = BasePath.Substring(0, BasePath.Length - 37)
   Dim SelectedFilename As String = BasePath + "$A_" + lstAttributeSets.Items(lstAttributeSets.SelectedIndex)
   If System.IO.File.Exists(SelectedFilename) Then
    Dim s As New System.IO.StreamReader(SelectedFilename)
    Dim input As String = s.ReadToEnd()
    s.Close()
    Dim inputstrings As String() = input.Split(vbCrLf)
    ' Parse all attributes in selected attribute set file
    Dim UnknownAttributes As String = ""
    Dim SelectedAttributes As New ArrayList
    For Each Attribute As String In inputstrings
     Dim TrimmedAttribute As String = Attribute.Trim()
     If TrimmedAttribute.Length > 0 Then
      Dim Found As Boolean = False
      For AttributeIndex As Integer = 0 To UniversalAttributeSet.Count - 1
       If UniversalAttributeSet(AttributeIndex) = TrimmedAttribute Then
        SelectedAttributes.Add(AttributeIndex)
        Found = True
       End If
      Next
      If Found = False Then
       UnknownAttributes = UnknownAttributes + TrimmedAttribute + " "
      End If
     End If
    Next
    If UnknownAttributes.Length > 0 Then
     MessageBox.Show("Error: Unknown attributes in selected attribute set: " + UnknownAttributes, "Error Loading Attribute Set", MessageBoxButtons.OK, MessageBoxIcon.Error)
    Else ' Valid attribute set - select all known icons
     lstSelectedAttributes.BeginUpdate()
     For i As Integer = 0 To lstSelectedAttributes.Items.Count - 1
      lstSelectedAttributes.SetSelected(i, False)
     Next
     For Each i As Integer In SelectedAttributes
      lstSelectedAttributes.SetSelected(i, True)
     Next
     lstSelectedAttributes.EndUpdate()
     lstSelectedAttributes.Refresh()
    End If
   End If
  End If
 End Sub

#End Region

End Class

Public Class LinClosure

#Region "Core functions"

 Public Function ComputeLinClosure(ByVal UniversalAttributeSet As ArrayList, ByVal ClosureAttributeSet As ArrayList, ByVal FDSet As ArrayList) As ArrayList
  ' Create Count ArrayList
  Dim Count As New ArrayList
  For Each FD As FunctionalDependency In FDSet
   Count.Add(FD.LeftHandSide.Count)
  Next
  ' Create Update and NewDep ArrayLists, and copy all attributes from ClosureAttributeSet into each
  Dim Update As New ArrayList
  Dim NewDep As New ArrayList
  ' Add all attributes to Update and NewDep
  For Each Attribute As Integer In ClosureAttributeSet
   Update.Add(Attribute)
   NewDep.Add(Attribute)
  Next
  ' Create FDList as an ArrayList of ArrayLists, one for each attribute in the universal attribute set,
  ' each pointing to each FDs that includes the attribute on its left-hand side
  Dim FDList As New ArrayList
  For AttributeIndex As Integer = 0 To UniversalAttributeSet.Count - 1
   Dim NewFDList As New ArrayList
   For FDIndex As Integer = 0 To FDSet.Count - 1
    Dim ExploreFD As FunctionalDependency = FDSet(FDIndex)
    Dim Found As Boolean = False
    For Each LHSItem As Integer In ExploreFD.LeftHandSide
     If LHSItem = AttributeIndex And Found = False Then
      Found = True
      NewFDList.Add(FDIndex)
     End If
    Next
   Next
   FDList.Add(NewFDList)
  Next

  ' Main loop
  While Update.Count > 0
   Dim Attribute As Integer = Update(0)
   Update.RemoveAt(0)
   Dim AttributeFDList As ArrayList = FDList(Attribute)
   For Each FDIndex As Integer In AttributeFDList
    Count(FDIndex) = Count(FDIndex) - 1
    If Count(FDIndex) = 0 Then
     Dim Add As New ArrayList
     Dim FD As FunctionalDependency = FDSet(FDIndex)
     For Each RHSItem As Integer In FD.RightHandSide
      Dim Found As Boolean = False
      For Each CurrentDependency As Integer In NewDep
       If CurrentDependency = RHSItem Then
        Found = True
       End If
      Next
      If Found = False Then
       Add.Add(RHSItem)
      End If
     Next
     For Each NewItem As Integer In Add
      Update.Add(NewItem)
      NewDep.Add(NewItem)
     Next
    End If
   Next
  End While
  Return NewDep
 End Function

#End Region

End Class
