' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' FunctionalDepdencyApplication - written by David J. Stein, Esq.
' This module is the central interface for the functional dependency application. All other classes are created and used within this class.

Public Class FunctionalDependencyApplication
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Private Attributes As ArrayList
 Private FunctionalDependencies As ArrayList

#Region " Windows Form Designer generated code "

 Public Sub New()
  MyBase.New()
  InitializeComponent()
  Me.Attributes = New ArrayList
  Me.FunctionalDependencies = New ArrayList
 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents btnCreateAttribute As System.Windows.Forms.Button
 Friend WithEvents lstAttributes As System.Windows.Forms.ListBox
 Friend WithEvents btnDeleteAttribute As System.Windows.Forms.Button
 Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
 Friend WithEvents btnSaveAttributeSet As System.Windows.Forms.Button
 Friend WithEvents btnLoadAttributeSet As System.Windows.Forms.Button
 Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
 Friend WithEvents btnLoadFunctionalDependency As System.Windows.Forms.Button
 Friend WithEvents btnSaveFunctionalDependency As System.Windows.Forms.Button
 Friend WithEvents lstFDSet As System.Windows.Forms.ListBox
 Friend WithEvents btnCreateFunctionalDependency As System.Windows.Forms.Button
 Friend WithEvents btnDeleteFunctionalDependency As System.Windows.Forms.Button
 Friend WithEvents btnTestAttributeSet As System.Windows.Forms.Button
 Friend WithEvents btnFindAllKeys As System.Windows.Forms.Button
 Friend WithEvents btnLinClosure As System.Windows.Forms.Button
 Friend WithEvents btnCheckBCNFStatus As System.Windows.Forms.Button
 Friend WithEvents btnCheck3NFStatus As System.Windows.Forms.Button
 Friend WithEvents btnCheck2NFStatus As System.Windows.Forms.Button
 Friend WithEvents btnCheckRedundancy As System.Windows.Forms.Button
 Friend WithEvents btnCheckDDerivation As System.Windows.Forms.Button
 Friend WithEvents btnMinimizeFDSet As System.Windows.Forms.Button
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(FunctionalDependencyApplication))
  Me.btnCreateAttribute = New System.Windows.Forms.Button
  Me.lstAttributes = New System.Windows.Forms.ListBox
  Me.btnDeleteAttribute = New System.Windows.Forms.Button
  Me.GroupBox1 = New System.Windows.Forms.GroupBox
  Me.btnLoadAttributeSet = New System.Windows.Forms.Button
  Me.btnSaveAttributeSet = New System.Windows.Forms.Button
  Me.GroupBox2 = New System.Windows.Forms.GroupBox
  Me.btnLoadFunctionalDependency = New System.Windows.Forms.Button
  Me.btnSaveFunctionalDependency = New System.Windows.Forms.Button
  Me.lstFDSet = New System.Windows.Forms.ListBox
  Me.btnCreateFunctionalDependency = New System.Windows.Forms.Button
  Me.btnDeleteFunctionalDependency = New System.Windows.Forms.Button
  Me.btnTestAttributeSet = New System.Windows.Forms.Button
  Me.btnFindAllKeys = New System.Windows.Forms.Button
  Me.btnLinClosure = New System.Windows.Forms.Button
  Me.btnCheckBCNFStatus = New System.Windows.Forms.Button
  Me.btnCheck3NFStatus = New System.Windows.Forms.Button
  Me.btnCheck2NFStatus = New System.Windows.Forms.Button
  Me.btnCheckRedundancy = New System.Windows.Forms.Button
  Me.btnCheckDDerivation = New System.Windows.Forms.Button
  Me.btnMinimizeFDSet = New System.Windows.Forms.Button
  Me.GroupBox1.SuspendLayout()
  Me.GroupBox2.SuspendLayout()
  Me.SuspendLayout()
  '
  'btnCreateAttribute
  '
  Me.btnCreateAttribute.Location = New System.Drawing.Point(16, 184)
  Me.btnCreateAttribute.Name = "btnCreateAttribute"
  Me.btnCreateAttribute.Size = New System.Drawing.Size(112, 23)
  Me.btnCreateAttribute.TabIndex = 0
  Me.btnCreateAttribute.Text = "Create Attribute"
  '
  'lstAttributes
  '
  Me.lstAttributes.Location = New System.Drawing.Point(16, 24)
  Me.lstAttributes.Name = "lstAttributes"
  Me.lstAttributes.Size = New System.Drawing.Size(112, 147)
  Me.lstAttributes.TabIndex = 1
  '
  'btnDeleteAttribute
  '
  Me.btnDeleteAttribute.Location = New System.Drawing.Point(16, 216)
  Me.btnDeleteAttribute.Name = "btnDeleteAttribute"
  Me.btnDeleteAttribute.Size = New System.Drawing.Size(112, 23)
  Me.btnDeleteAttribute.TabIndex = 1
  Me.btnDeleteAttribute.Text = "Delete Attribute"
  '
  'GroupBox1
  '
  Me.GroupBox1.Controls.Add(Me.btnLoadAttributeSet)
  Me.GroupBox1.Controls.Add(Me.btnSaveAttributeSet)
  Me.GroupBox1.Controls.Add(Me.lstAttributes)
  Me.GroupBox1.Controls.Add(Me.btnCreateAttribute)
  Me.GroupBox1.Controls.Add(Me.btnDeleteAttribute)
  Me.GroupBox1.Location = New System.Drawing.Point(16, 16)
  Me.GroupBox1.Name = "GroupBox1"
  Me.GroupBox1.Size = New System.Drawing.Size(144, 320)
  Me.GroupBox1.TabIndex = 0
  Me.GroupBox1.TabStop = False
  Me.GroupBox1.Text = "Current Attribute Set"
  '
  'btnLoadAttributeSet
  '
  Me.btnLoadAttributeSet.Location = New System.Drawing.Point(16, 248)
  Me.btnLoadAttributeSet.Name = "btnLoadAttributeSet"
  Me.btnLoadAttributeSet.Size = New System.Drawing.Size(112, 23)
  Me.btnLoadAttributeSet.TabIndex = 2
  Me.btnLoadAttributeSet.Text = "Load Attribute Set"
  '
  'btnSaveAttributeSet
  '
  Me.btnSaveAttributeSet.Location = New System.Drawing.Point(16, 280)
  Me.btnSaveAttributeSet.Name = "btnSaveAttributeSet"
  Me.btnSaveAttributeSet.Size = New System.Drawing.Size(112, 23)
  Me.btnSaveAttributeSet.TabIndex = 3
  Me.btnSaveAttributeSet.Text = "Save Attribute Set"
  '
  'GroupBox2
  '
  Me.GroupBox2.Controls.Add(Me.btnLoadFunctionalDependency)
  Me.GroupBox2.Controls.Add(Me.btnSaveFunctionalDependency)
  Me.GroupBox2.Controls.Add(Me.lstFDSet)
  Me.GroupBox2.Controls.Add(Me.btnCreateFunctionalDependency)
  Me.GroupBox2.Controls.Add(Me.btnDeleteFunctionalDependency)
  Me.GroupBox2.Location = New System.Drawing.Point(176, 16)
  Me.GroupBox2.Name = "GroupBox2"
  Me.GroupBox2.Size = New System.Drawing.Size(216, 320)
  Me.GroupBox2.TabIndex = 1
  Me.GroupBox2.TabStop = False
  Me.GroupBox2.Text = "Current Functional Dependency Set"
  '
  'btnLoadFunctionalDependency
  '
  Me.btnLoadFunctionalDependency.Location = New System.Drawing.Point(16, 248)
  Me.btnLoadFunctionalDependency.Name = "btnLoadFunctionalDependency"
  Me.btnLoadFunctionalDependency.Size = New System.Drawing.Size(184, 23)
  Me.btnLoadFunctionalDependency.TabIndex = 2
  Me.btnLoadFunctionalDependency.Text = "Load Functional Dependency Set"
  '
  'btnSaveFunctionalDependency
  '
  Me.btnSaveFunctionalDependency.Location = New System.Drawing.Point(16, 280)
  Me.btnSaveFunctionalDependency.Name = "btnSaveFunctionalDependency"
  Me.btnSaveFunctionalDependency.Size = New System.Drawing.Size(184, 23)
  Me.btnSaveFunctionalDependency.TabIndex = 3
  Me.btnSaveFunctionalDependency.Text = "Save Functional Dependency Set"
  '
  'lstFDSet
  '
  Me.lstFDSet.Location = New System.Drawing.Point(16, 24)
  Me.lstFDSet.Name = "lstFDSet"
  Me.lstFDSet.Size = New System.Drawing.Size(184, 147)
  Me.lstFDSet.TabIndex = 1
  '
  'btnCreateFunctionalDependency
  '
  Me.btnCreateFunctionalDependency.Location = New System.Drawing.Point(16, 184)
  Me.btnCreateFunctionalDependency.Name = "btnCreateFunctionalDependency"
  Me.btnCreateFunctionalDependency.Size = New System.Drawing.Size(184, 23)
  Me.btnCreateFunctionalDependency.TabIndex = 0
  Me.btnCreateFunctionalDependency.Text = "Create Functional Dependency"
  '
  'btnDeleteFunctionalDependency
  '
  Me.btnDeleteFunctionalDependency.Location = New System.Drawing.Point(16, 216)
  Me.btnDeleteFunctionalDependency.Name = "btnDeleteFunctionalDependency"
  Me.btnDeleteFunctionalDependency.Size = New System.Drawing.Size(184, 23)
  Me.btnDeleteFunctionalDependency.TabIndex = 1
  Me.btnDeleteFunctionalDependency.Text = "Delete Functional Dependency"
  '
  'btnTestAttributeSet
  '
  Me.btnTestAttributeSet.Location = New System.Drawing.Point(16, 344)
  Me.btnTestAttributeSet.Name = "btnTestAttributeSet"
  Me.btnTestAttributeSet.Size = New System.Drawing.Size(112, 23)
  Me.btnTestAttributeSet.TabIndex = 2
  Me.btnTestAttributeSet.Text = "Attribute Key Test"
  '
  'btnFindAllKeys
  '
  Me.btnFindAllKeys.Location = New System.Drawing.Point(144, 344)
  Me.btnFindAllKeys.Name = "btnFindAllKeys"
  Me.btnFindAllKeys.Size = New System.Drawing.Size(112, 23)
  Me.btnFindAllKeys.TabIndex = 3
  Me.btnFindAllKeys.Text = "Find All Keys"
  '
  'btnLinClosure
  '
  Me.btnLinClosure.Location = New System.Drawing.Point(272, 344)
  Me.btnLinClosure.Name = "btnLinClosure"
  Me.btnLinClosure.Size = New System.Drawing.Size(120, 23)
  Me.btnLinClosure.TabIndex = 4
  Me.btnLinClosure.Text = "Find Lin Closure"
  '
  'btnCheckBCNFStatus
  '
  Me.btnCheckBCNFStatus.Location = New System.Drawing.Point(272, 376)
  Me.btnCheckBCNFStatus.Name = "btnCheckBCNFStatus"
  Me.btnCheckBCNFStatus.Size = New System.Drawing.Size(120, 23)
  Me.btnCheckBCNFStatus.TabIndex = 7
  Me.btnCheckBCNFStatus.Text = "Check BCNF Status"
  '
  'btnCheck3NFStatus
  '
  Me.btnCheck3NFStatus.Location = New System.Drawing.Point(144, 376)
  Me.btnCheck3NFStatus.Name = "btnCheck3NFStatus"
  Me.btnCheck3NFStatus.Size = New System.Drawing.Size(112, 23)
  Me.btnCheck3NFStatus.TabIndex = 6
  Me.btnCheck3NFStatus.Text = "Check 3NF Status"
  '
  'btnCheck2NFStatus
  '
  Me.btnCheck2NFStatus.Location = New System.Drawing.Point(16, 376)
  Me.btnCheck2NFStatus.Name = "btnCheck2NFStatus"
  Me.btnCheck2NFStatus.Size = New System.Drawing.Size(112, 23)
  Me.btnCheck2NFStatus.TabIndex = 5
  Me.btnCheck2NFStatus.Text = "Check 2NF Status"
  '
  'btnCheckRedundancy
  '
  Me.btnCheckRedundancy.Location = New System.Drawing.Point(16, 408)
  Me.btnCheckRedundancy.Name = "btnCheckRedundancy"
  Me.btnCheckRedundancy.Size = New System.Drawing.Size(112, 23)
  Me.btnCheckRedundancy.TabIndex = 8
  Me.btnCheckRedundancy.Text = "Check Redundancy"
  '
  'btnCheckDDerivation
  '
  Me.btnCheckDDerivation.Location = New System.Drawing.Point(144, 408)
  Me.btnCheckDDerivation.Name = "btnCheckDDerivation"
  Me.btnCheckDDerivation.Size = New System.Drawing.Size(112, 23)
  Me.btnCheckDDerivation.TabIndex = 9
  Me.btnCheckDDerivation.Text = "Check DDerivation"
  '
  'btnMinimizeFDSet
  '
  Me.btnMinimizeFDSet.Location = New System.Drawing.Point(272, 408)
  Me.btnMinimizeFDSet.Name = "btnMinimizeFDSet"
  Me.btnMinimizeFDSet.Size = New System.Drawing.Size(120, 23)
  Me.btnMinimizeFDSet.TabIndex = 10
  Me.btnMinimizeFDSet.Text = "Minimize FD Set"
  '
  'FunctionalDependencyApplication
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(408, 448)
  Me.Controls.Add(Me.btnCheckRedundancy)
  Me.Controls.Add(Me.btnCheckDDerivation)
  Me.Controls.Add(Me.btnMinimizeFDSet)
  Me.Controls.Add(Me.btnCheck2NFStatus)
  Me.Controls.Add(Me.btnCheck3NFStatus)
  Me.Controls.Add(Me.btnCheckBCNFStatus)
  Me.Controls.Add(Me.btnLinClosure)
  Me.Controls.Add(Me.btnFindAllKeys)
  Me.Controls.Add(Me.btnTestAttributeSet)
  Me.Controls.Add(Me.GroupBox1)
  Me.Controls.Add(Me.GroupBox2)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.MaximizeBox = False
  Me.MinimizeBox = False
  Me.Name = "FunctionalDependencyApplication"
  Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide
  Me.Text = "Functional Dependency Application"
  Me.GroupBox1.ResumeLayout(False)
  Me.GroupBox2.ResumeLayout(False)
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub btnCreateAttribute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateAttribute.Click
  Dim NewAttributeForm As New AddEditAttribute
  If NewAttributeForm.ShowDialog(Me) = DialogResult.OK And NewAttributeForm.txtAttributeName.Text.Length > 0 And NewAttributeForm.txtAttributeName.Text <> "->" Then
   Dim AcceptableAttribute As Boolean
   AcceptableAttribute = True
   For Each Attribute As String In Attributes
    If Attribute = NewAttributeForm.txtAttributeName.Text Then
     System.Windows.Forms.MessageBox.Show("Attribute named " + Attribute + " already exists.", "Error Adding Attribute", MessageBoxButtons.OK, MessageBoxIcon.Error)
     AcceptableAttribute = False
    End If
   Next
   If AcceptableAttribute = True Then
    Attributes.Add(NewAttributeForm.txtAttributeName.Text)
    UpdateAttributesList()
    UpdateFunctionalDependenciesList()
   End If
  End If
 End Sub
 Private Sub UpdateAttributesList()
  lstAttributes.BeginUpdate()
  lstAttributes.Items.Clear()
  For Each Attribute As Object In Attributes
   lstAttributes.Items.Add(Attribute)
  Next
  lstAttributes.EndUpdate()
  lstAttributes.Refresh()
 End Sub
 Private Sub UpdateFunctionalDependenciesList()
  lstFDSet.BeginUpdate()
  lstFDSet.Items.Clear()
  For Each FD As FunctionalDependency In FunctionalDependencies
   Dim FDString As String = ""
   For Each LHSItem As Integer In FD.LeftHandSide
    FDString += Attributes(LHSItem) + " "
   Next
   FDString += "-> "
   For Each RHSItem As Integer In FD.RightHandSide
    FDString += Attributes(RHSItem) + " "
   Next
   lstFDSet.Items.Add(FDString)
  Next
  lstFDSet.EndUpdate()
  lstFDSet.Refresh()
 End Sub

 Private Sub btnDeleteAttribute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeleteAttribute.Click
  If lstAttributes.SelectedIndex <> -1 Then
   Attributes.RemoveAt(lstAttributes.SelectedIndex)
   ' Remove every functional dependency that references this item.
   Dim RemoveFDs As New ArrayList
   For Each FD As FunctionalDependency In FunctionalDependencies
    Dim Found As Boolean = False
    For Each LHSItem As Integer In FD.LeftHandSide
     If LHSItem = lstAttributes.SelectedIndex Then
      Found = True
     End If
    Next
    For Each RHSItem As Integer In FD.RightHandSide
     If RHSItem = lstAttributes.SelectedIndex Then
      Found = True
     End If
    Next
    If Found = True Then
     RemoveFDs.Add(FD)
    End If
   Next
   For Each FD As FunctionalDependency In RemoveFDs
    FunctionalDependencies.Remove(FD)
   Next
   ' Decrement each attribute reference above the deleted attribute in each functional dependency.
   For Each FD As FunctionalDependency In FunctionalDependencies
    For i As Integer = 0 To FD.LeftHandSide.Count - 1
     If FD.LeftHandSide(i) > lstAttributes.SelectedIndex Then
      FD.LeftHandSide(i) = FD.LeftHandSide(i) - 1
     End If
    Next
    For i As Integer = 0 To FD.RightHandSide.Count - 1
     If FD.RightHandSide(i) > lstAttributes.SelectedIndex Then
      FD.RightHandSide(i) = FD.RightHandSide(i) - 1
     End If
    Next
   Next
   ' now update lists
   UpdateAttributesList()
   UpdateFunctionalDependenciesList()
  End If
 End Sub

 Private Sub lstAttributes_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstAttributes.DoubleClick
  If lstAttributes.SelectedIndex <> -1 Then
   Dim NewAttributeForm As New AddEditAttribute(Attributes.Item(lstAttributes.SelectedIndex))
   If NewAttributeForm.ShowDialog() = DialogResult.OK And NewAttributeForm.txtAttributeName.Text.Length > 0 And NewAttributeForm.txtAttributeName.Text <> "->" Then
    Dim AcceptableAttribute As Boolean = True
    For i As Integer = 0 To Attributes.Count - 1
     If i <> lstAttributes.SelectedIndex And Attributes(i) = NewAttributeForm.txtAttributeName.Text Then
      System.Windows.Forms.MessageBox.Show("Attribute named " + Attributes(i) + " already exists.", "Error Adding Attribute", MessageBoxButtons.OK, MessageBoxIcon.Error)
      AcceptableAttribute = False
     End If
    Next
    If AcceptableAttribute = True Then
     Attributes.Item(lstAttributes.SelectedIndex) = NewAttributeForm.txtAttributeName.Text
     UpdateAttributesList()
     UpdateFunctionalDependenciesList()
    End If
   End If
  End If
 End Sub

 Private Sub btnSaveAttributeSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveAttributeSet.Click
  Dim s As New SaveAttributeSet
  If s.ShowDialog(Me) = DialogResult.OK And s.txtFilename.Text.Length > 0 Then
   Dim output As New System.IO.StreamWriter(s.SelectedFullFilename)
   For Each Attribute As String In Attributes
    output.WriteLine(Attribute)
   Next
   output.Close()

   ' update catalog ($AN)
   ' first read catalog to see if attribute set is already listed
   Dim WriteEntry As Boolean = True
   Dim catalogname As String
   catalogname = s.BasePath + "$AN"
   If (System.IO.File.Exists(catalogname)) Then   ' check catalog for names
    Dim readcatalog As New System.IO.StreamReader(catalogname)
    Dim input As String
    input = readcatalog.ReadToEnd()
    readcatalog.Close()
    Dim inputstrings As String() = Nothing
    inputstrings = input.Split()
    For Each CatalogAttributeSetName As String In inputstrings
     If s.SelectedFilename = CatalogAttributeSetName Then
      WriteEntry = False
     End If
    Next
   End If
   If WriteEntry = True Then  ' add entry
    Dim writecatalog As New System.IO.StreamWriter(catalogname, True)
    writecatalog.WriteLine(s.SelectedFilename)
    writecatalog.Close()
   End If
  End If
 End Sub

 Private Sub btnLoadAttributeSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadAttributeSet.Click
  Dim LoadAttributes As New LoadAttributeSet
  If LoadAttributes.ShowDialog(Me) = DialogResult.OK Then
   Attributes = New ArrayList
   Dim input As New System.IO.StreamReader(LoadAttributes.SelectedFilename)
   Dim inputstring As String
   inputstring = input.ReadToEnd()
   input.Close()
   Dim inputstrings As String() = inputstring.Split()
   For Each Attribute As String In inputstrings
    If Attribute.Length > 0 And Attribute <> "->" Then
     Attributes.Add(Attribute)
    End If
   Next
   UpdateAttributesList()
   ' Since FD references are no longer pointing to the FD set in memory, vaporize it.
   FunctionalDependencies = New ArrayList
   UpdateFunctionalDependenciesList()
  End If
 End Sub

 Private Sub btnCreateFunctionalDependency_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreateFunctionalDependency.Click
  Dim NewFunctionalDependencyForm As New AddEditFDSet(Attributes)
  If NewFunctionalDependencyForm.ShowDialog(Me) = DialogResult.OK Then
   Dim NewFunctionalDependency As New FunctionalDependency
   For i As Integer = 0 To Attributes.Count - 1
    If NewFunctionalDependencyForm.lstLeftHandSide.GetSelected(i) = True Then
     NewFunctionalDependency.LeftHandSide.Add(i)
    End If
    If NewFunctionalDependencyForm.lstRightHandSide.GetSelected(i) = True Then
     NewFunctionalDependency.RightHandSide.Add(i)
    End If
   Next
   ' now check whether this FD is a duplicate
   Dim FDExists As Boolean = False
   For Each CurrentFunctionalDependency As FunctionalDependency In FunctionalDependencies
    If CurrentFunctionalDependency.LeftHandSide.Count = NewFunctionalDependency.LeftHandSide.Count And CurrentFunctionalDependency.RightHandSide.Count = NewFunctionalDependency.RightHandSide.Count Then
     Dim Different As Boolean = False
     For Each LHSCurrentIndex As Integer In CurrentFunctionalDependency.LeftHandSide
      Dim Found As Boolean = False
      For Each LHSNewIndex As Integer In NewFunctionalDependency.LeftHandSide
       If LHSCurrentIndex = LHSNewIndex Then
        Found = True
       End If
      Next
      If Found = False Then
       Different = True
      End If
     Next
     For Each RHSCurrentIndex As Integer In CurrentFunctionalDependency.RightHandSide
      Dim Found As Boolean = False
      For Each RHSNewIndex As Integer In NewFunctionalDependency.RightHandSide
       If RHSCurrentIndex = RHSNewIndex Then
        Found = True
       End If
      Next
      If Found = False Then
       Different = True
      End If
     Next
     If Different = False Then
      FDExists = True
     End If
    End If
   Next
   If FDExists = True Then
    Windows.Forms.MessageBox.Show("Error: This functional dependency already exists.", "Error Adding Functional Dependency", MessageBoxButtons.OK, MessageBoxIcon.Error)
   Else
    FunctionalDependencies.Add(NewFunctionalDependency)
    UpdateFunctionalDependenciesList()
   End If
  End If
 End Sub

 Private Sub btnDeleteFunctionalDependency_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeleteFunctionalDependency.Click
  If lstFDSet.SelectedIndex <> -1 Then
   FunctionalDependencies.RemoveAt(lstFDSet.SelectedIndex)
   UpdateFunctionalDependenciesList()
  End If
 End Sub

 Private Sub lstFDSet_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstFDSet.DoubleClick
  If lstFDSet.SelectedIndex <> -1 Then
   Dim NewFunctionalDependencyForm As New AddEditFDSet(Attributes, FunctionalDependencies(lstFDSet.SelectedIndex))
   If NewFunctionalDependencyForm.ShowDialog() = DialogResult.OK Then  ' update functional dependencies
    Dim EditFunctionalDependency As FunctionalDependency = FunctionalDependencies(lstFDSet.SelectedIndex)
    EditFunctionalDependency.LeftHandSide.Clear()
    EditFunctionalDependency.RightHandSide.Clear()
    For i As Integer = 0 To Attributes.Count - 1
     If NewFunctionalDependencyForm.lstLeftHandSide.GetSelected(i) = True Then
      EditFunctionalDependency.LeftHandSide.Add(i)
     End If
     If NewFunctionalDependencyForm.lstRightHandSide.GetSelected(i) = True Then
      EditFunctionalDependency.RightHandSide.Add(i)
     End If
    Next
    ' now check whether this FD is a duplicate
    Dim FDExists As Boolean = False
    For index As Integer = 0 To FunctionalDependencies.Count - 1
     Dim CurrentFunctionalDependency As FunctionalDependency = FunctionalDependencies(index)
     If index <> lstFDSet.SelectedIndex And CurrentFunctionalDependency.LeftHandSide.Count = EditFunctionalDependency.LeftHandSide.Count And CurrentFunctionalDependency.RightHandSide.Count = EditFunctionalDependency.RightHandSide.Count Then
      Dim Different As Boolean = False
      For Each LHSCurrentIndex As Integer In CurrentFunctionalDependency.LeftHandSide
       Dim Found As Boolean = False
       For Each LHSNewIndex As Integer In EditFunctionalDependency.LeftHandSide
        If LHSCurrentIndex = LHSNewIndex Then
         Found = True
        End If
       Next
       If Found = False Then
        Different = True
       End If
      Next
      For Each RHSCurrentIndex As Integer In CurrentFunctionalDependency.RightHandSide
       Dim Found As Boolean = False
       For Each RHSNewIndex As Integer In EditFunctionalDependency.RightHandSide
        If RHSCurrentIndex = RHSNewIndex Then
         Found = True
        End If
       Next
       If Found = False Then
        Different = True
       End If
      Next
      If Different = False Then
       FDExists = True
      End If
     End If
    Next
    If FDExists = True Then
     Windows.Forms.MessageBox.Show("Error: This functional dependency already exists.", "Error Adding Functional Dependency", MessageBoxButtons.OK, MessageBoxIcon.Error)
     FunctionalDependencies.RemoveAt(lstFDSet.SelectedIndex)
    End If
    UpdateFunctionalDependenciesList()
   End If
  End If
 End Sub

 Private Sub btnSaveFunctionalDependency_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveFunctionalDependency.Click
  Dim s As New SaveFDSet
  If s.ShowDialog(Me) = DialogResult.OK And s.txtFilename.Text.Length > 0 Then
   Dim output As New System.IO.StreamWriter(s.SelectedFullFilename)
   For Each FD As FunctionalDependency In FunctionalDependencies
    For Each LHSItem As Integer In FD.LeftHandSide
     output.Write(Attributes(LHSItem) + " ")
    Next
    output.Write("-> ")
    For Each RHSItem As Integer In FD.RightHandSide
     output.Write(Attributes(RHSItem) + " ")
    Next
    output.WriteLine("")
   Next
   output.Close()

   ' update catalog ($FN)
   ' first read catalog to see if attribute set is already listed
   Dim WriteEntry As Boolean = True
   Dim catalogname As String
   catalogname = s.BasePath + "$FN"
   If (System.IO.File.Exists(catalogname)) Then   ' check catalog for names
    Dim readcatalog As New System.IO.StreamReader(catalogname)
    Dim input As String
    input = readcatalog.ReadToEnd()
    readcatalog.Close()
    Dim inputstrings As String() = Nothing
    inputstrings = input.Split()
    For Each CatalogFDSetName As String In inputstrings
     If s.SelectedFilename = CatalogFDSetName Then
      WriteEntry = False
     End If
    Next
   End If
   If WriteEntry = True Then  ' add entry
    Dim writecatalog As New System.IO.StreamWriter(catalogname, True)
    writecatalog.WriteLine(s.SelectedFilename)
    writecatalog.Close()
   End If
  End If
 End Sub

 Private Sub btnLoadFunctionalDependency_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadFunctionalDependency.Click
  Dim LoadFDSet As New LoadFDSet
  If LoadFDSet.ShowDialog(Me) = DialogResult.OK Then
   Dim NewFDSet As New ArrayList
   Dim UnknownSymbols As New ArrayList
   Dim input As New System.IO.StreamReader(LoadFDSet.SelectedFilename)
   Dim inputstring As String
   inputstring = input.ReadToEnd()
   input.Close()
   Dim inputstrings As String() = inputstring.Split(vbCrLf)
   For Each FDString As String In inputstrings
    If FDString.Length > 0 Then
     Dim NewFD As New FunctionalDependency
     Dim tokenstrings As String() = FDString.Split(" ")
     Dim ParseError As Boolean
     Dim CurrentSide As Integer = 0  ' 0 = currently parsing LHS; 1 = currently parsing RHS
     For Each token As String In tokenstrings
      ParseError = False
      token = token.Trim()
      If token = "->" Then
       If CurrentSide = 0 Then
        CurrentSide = 1
       Else
        ParseError = True
       End If
      ElseIf token.Length > 0 Then
       Dim Found As Boolean = False
       For index As Integer = 0 To Attributes.Count - 1
        If Attributes(index) = token Then
         Found = True
         If CurrentSide = 0 Then
          NewFD.LeftHandSide.Add(index)
         Else
          NewFD.RightHandSide.Add(index)
         End If
        End If
       Next
       If Found = False Then  ' found unknown symbol
        ParseError = True
        Found = False
        For Each UnknownSymbol As String In UnknownSymbols
         If UnknownSymbol = token Then
          Found = True
         End If
        Next
        If Found = False Then
         UnknownSymbols.Add(token)
        End If
       End If
      End If
     Next
     If ParseError = False And (NewFD.LeftHandSide.Count > 0 Or NewFD.RightHandSide.Count > 0) Then
      NewFDSet.Add(NewFD)
     End If
    End If
   Next
   If UnknownSymbols.Count = 0 Then
    FunctionalDependencies = NewFDSet
    UpdateFunctionalDependenciesList()
   Else
    Dim ErrorString As String = "Error: " + UnknownSymbols.Count.ToString() + " Unknown Symbols Found: "
    For Each UnknownSymbol As String In UnknownSymbols
     ErrorString += UnknownSymbol + " "
    Next
    MessageBox.Show(ErrorString, "Error Loading FD Set", MessageBoxButtons.OK, MessageBoxIcon.Error)
   End If
  End If
 End Sub

 Private Sub btnLinClosure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLinClosure.Click
  Dim f As New FindLinClosure(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  f.ShowDialog()
 End Sub

 Private Sub btnTestAttributeSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTestAttributeSet.Click
  Dim f As New TestAttributeSetAsKey(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  f.ShowDialog()
 End Sub

 Private Sub btnFindAllKeys_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFindAllKeys.Click
  Dim f As New FindKeys(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  f.ShowDialog()
 End Sub

 Private Sub btnCheckBCNFStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckBCNFStatus.Click
  Dim c As New CheckBCNFStatus(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  c.ShowDialog(Me)
 End Sub

 Private Sub btnCheck3NFStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheck3NFStatus.Click
  Dim c As New Check3NFStatus(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  c.ShowDialog(Me)
 End Sub

 Private Sub btnCheck2NFStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheck2NFStatus.Click
  Dim c As New Check_2NF_Status(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  c.ShowDialog(Me)
 End Sub

 Private Sub btnCheckDDerivation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckDDerivation.Click
  Dim d As New CheckDirectDerivation(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  d.ShowDialog()
 End Sub

 Private Sub btnCheckRedundancy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckRedundancy.Click
  Dim r As New CheckRedundancy(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  r.ShowDialog()
  FunctionalDependencies = r.ReturnedFunctionalDependencies
  UpdateFunctionalDependenciesList()
 End Sub

 Private Sub btnMinimizeFDSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMinimizeFDSet.Click
  Dim m As New CheckMinimum(Attributes, FunctionalDependencies, Location.X + Width, Location.Y)
  m.ShowDialog()
  FunctionalDependencies = m.ReturnedFunctionalDependencies
  UpdateFunctionalDependenciesList()
 End Sub

#End Region

End Class

Public Class FunctionalDependency

#Region "Variables and initialization code"

 Friend LeftHandSide As ArrayList
 Friend RightHandSide As ArrayList

 Public Sub New()
  MyBase.New()
  LeftHandSide = New ArrayList
  RightHandSide = New ArrayList
 End Sub

#End Region

End Class
