' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' LoadAttributeSet - written by David J. Stein, Esq.
' This module loads an attribute set from disk.

Public Class LoadAttributeSet
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Friend SelectedFilename As String = ""

 Private Sub LoadAttributeSet_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  Dim BasePath As String = System.Reflection.Assembly.GetExecutingAssembly().Location
  BasePath = BasePath.Substring(0, BasePath.Length - 37)
  SelectedFilename = BasePath
  Dim DirectoryName As String = BasePath + "$AN"
  If System.IO.File.Exists(DirectoryName) Then
   lstFiles.BeginUpdate()
   Dim s As New System.IO.StreamReader(DirectoryName)
   Dim input As String = s.ReadToEnd()
   s.Close()
   Dim inputstrings As String() = input.Split(vbCrLf)
   For Each filename As String In inputstrings
    Dim trimmedfilename As String = filename.Trim()
    If trimmedfilename.Length > 0 And System.IO.File.Exists(BasePath + "$A_" + trimmedfilename) Then
     lstFiles.Items.Add(trimmedfilename)
    End If
   Next
   lstFiles.EndUpdate()
  End If
 End Sub

#Region " Windows Form Designer generated code "

 Public Sub New()
  MyBase.New()

  'This call is required by the Windows Form Designer.
  InitializeComponent()

  'Add any initialization after the InitializeComponent() call

 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents Label1 As System.Windows.Forms.Label
 Friend WithEvents lstFiles As System.Windows.Forms.ListBox
 Friend WithEvents btnCancel As System.Windows.Forms.Button
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(LoadAttributeSet))
  Me.Label1 = New System.Windows.Forms.Label
  Me.lstFiles = New System.Windows.Forms.ListBox
  Me.btnCancel = New System.Windows.Forms.Button
  Me.SuspendLayout()
  '
  'Label1
  '
  Me.Label1.Location = New System.Drawing.Point(8, 8)
  Me.Label1.Name = "Label1"
  Me.Label1.Size = New System.Drawing.Size(144, 40)
  Me.Label1.TabIndex = 0
  Me.Label1.Text = "Double-click any attribute set name to load it:"
  Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'lstFiles
  '
  Me.lstFiles.Location = New System.Drawing.Point(8, 56)
  Me.lstFiles.Name = "lstFiles"
  Me.lstFiles.Size = New System.Drawing.Size(144, 134)
  Me.lstFiles.TabIndex = 0
  '
  'btnCancel
  '
  Me.btnCancel.Location = New System.Drawing.Point(43, 200)
  Me.btnCancel.Name = "btnCancel"
  Me.btnCancel.TabIndex = 1
  Me.btnCancel.Text = "Cancel"
  '
  'LoadAttributeSet
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(160, 230)
  Me.Controls.Add(Me.btnCancel)
  Me.Controls.Add(Me.lstFiles)
  Me.Controls.Add(Me.Label1)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.MaximizeBox = False
  Me.MinimizeBox = False
  Me.Name = "LoadAttributeSet"
  Me.ShowInTaskbar = False
  Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
  Me.Text = "Load Attribute Set"
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub lstFiles_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstFiles.DoubleClick
  If lstFiles.SelectedIndex <> -1 Then
   SelectedFilename = SelectedFilename + "$A_" + lstFiles.Items(lstFiles.SelectedIndex)
   DialogResult = DialogResult.OK
   Close()
  End If
 End Sub

 Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
  DialogResult = DialogResult.Cancel
  Close()
 End Sub

#End Region

End Class
