' Functional Dependency Application
' Written by David J. Stein, Esq., Kevin Hardy, and Craig White. See "License.html" for terms and conditions of use.
'
' TestAttributeSetAsKey - written by David J. Stein, Esq.
' This module tests whether a specified attribute subset is a key for the attribute set, given a set of functional dependencies.

Public Class TestAttributeSetAsKey
 Inherits System.Windows.Forms.Form

#Region "Variables and initialization code"

 Dim UniversalAttributeSet As ArrayList
 Dim FDSet As ArrayList
 Private x As Integer
 Private y As Integer

#Region " Windows Form Designer generated code "

 Public Sub New(ByVal UniversalAttributeSet As ArrayList, ByVal FDSet As ArrayList, ByVal x As Integer, ByVal y As Integer)
  MyBase.New()
  InitializeComponent()
  Me.x = x
  Me.y = y
  Me.UniversalAttributeSet = UniversalAttributeSet
  Me.FDSet = FDSet
 End Sub

 'Form overrides dispose to clean up the component list.
 Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
  If disposing Then
   If Not (components Is Nothing) Then
    components.Dispose()
   End If
  End If
  MyBase.Dispose(disposing)
 End Sub

 'Required by the Windows Form Designer
 Private components As System.ComponentModel.IContainer

 'NOTE: The following procedure is required by the Windows Form Designer
 'It can be modified using the Windows Form Designer.  
 'Do not modify it using the code editor.
 Friend WithEvents lstAttributeSets As System.Windows.Forms.ListBox
 Friend WithEvents Label2 As System.Windows.Forms.Label
 Friend WithEvents btnTestKeySelectedAttributes As System.Windows.Forms.Button
 Friend WithEvents lstSelectedAttributes As System.Windows.Forms.ListBox
 Friend WithEvents Label1 As System.Windows.Forms.Label
 Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
 Friend WithEvents txtResults As System.Windows.Forms.TextBox
 <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
  Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(TestAttributeSetAsKey))
  Me.lstAttributeSets = New System.Windows.Forms.ListBox
  Me.Label2 = New System.Windows.Forms.Label
  Me.btnTestKeySelectedAttributes = New System.Windows.Forms.Button
  Me.lstSelectedAttributes = New System.Windows.Forms.ListBox
  Me.Label1 = New System.Windows.Forms.Label
  Me.GroupBox1 = New System.Windows.Forms.GroupBox
  Me.txtResults = New System.Windows.Forms.TextBox
  Me.GroupBox1.SuspendLayout()
  Me.SuspendLayout()
  '
  'lstAttributeSets
  '
  Me.lstAttributeSets.Location = New System.Drawing.Point(144, 48)
  Me.lstAttributeSets.Name = "lstAttributeSets"
  Me.lstAttributeSets.Size = New System.Drawing.Size(112, 173)
  Me.lstAttributeSets.TabIndex = 1
  '
  'Label2
  '
  Me.Label2.Location = New System.Drawing.Point(144, 16)
  Me.Label2.Name = "Label2"
  Me.Label2.Size = New System.Drawing.Size(112, 32)
  Me.Label2.TabIndex = 12
  Me.Label2.Text = "Or Double-Click a Known Attribute Set:"
  Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'btnTestKeySelectedAttributes
  '
  Me.btnTestKeySelectedAttributes.Location = New System.Drawing.Point(64, 232)
  Me.btnTestKeySelectedAttributes.Name = "btnTestKeySelectedAttributes"
  Me.btnTestKeySelectedAttributes.Size = New System.Drawing.Size(144, 23)
  Me.btnTestKeySelectedAttributes.TabIndex = 2
  Me.btnTestKeySelectedAttributes.Text = "Test Selected Attributes"
  '
  'lstSelectedAttributes
  '
  Me.lstSelectedAttributes.Location = New System.Drawing.Point(16, 48)
  Me.lstSelectedAttributes.Name = "lstSelectedAttributes"
  Me.lstSelectedAttributes.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple
  Me.lstSelectedAttributes.Size = New System.Drawing.Size(112, 173)
  Me.lstSelectedAttributes.TabIndex = 0
  '
  'Label1
  '
  Me.Label1.Location = New System.Drawing.Point(16, 16)
  Me.Label1.Name = "Label1"
  Me.Label1.Size = New System.Drawing.Size(120, 32)
  Me.Label1.TabIndex = 9
  Me.Label1.Text = "Select Attributes From Current Attribute Set:"
  Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
  '
  'GroupBox1
  '
  Me.GroupBox1.Controls.Add(Me.txtResults)
  Me.GroupBox1.Location = New System.Drawing.Point(16, 264)
  Me.GroupBox1.Name = "GroupBox1"
  Me.GroupBox1.Size = New System.Drawing.Size(240, 176)
  Me.GroupBox1.TabIndex = 15
  Me.GroupBox1.TabStop = False
  Me.GroupBox1.Text = "Results"
  '
  'txtResults
  '
  Me.txtResults.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
  Me.txtResults.Location = New System.Drawing.Point(8, 16)
  Me.txtResults.Multiline = True
  Me.txtResults.Name = "txtResults"
  Me.txtResults.ReadOnly = True
  Me.txtResults.Size = New System.Drawing.Size(224, 152)
  Me.txtResults.TabIndex = 0
  Me.txtResults.Text = ""
  '
  'TestAttributeSetAsKey
  '
  Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
  Me.ClientSize = New System.Drawing.Size(272, 448)
  Me.Controls.Add(Me.GroupBox1)
  Me.Controls.Add(Me.lstAttributeSets)
  Me.Controls.Add(Me.Label2)
  Me.Controls.Add(Me.btnTestKeySelectedAttributes)
  Me.Controls.Add(Me.lstSelectedAttributes)
  Me.Controls.Add(Me.Label1)
  Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
  Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
  Me.MaximizeBox = False
  Me.MinimizeBox = False
  Me.Name = "TestAttributeSetAsKey"
  Me.ShowInTaskbar = False
  Me.Text = "Test Attribute Set As Key"
  Me.GroupBox1.ResumeLayout(False)
  Me.ResumeLayout(False)

 End Sub

#End Region

#End Region

#Region "Button-click event handlers"

 Private Sub btnTestKeySelectedAttributes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTestKeySelectedAttributes.Click
  ' Construct selected array list to pass to LinClosure function
  Dim KeyAttributeSet As New ArrayList
  For i As Integer = 0 To lstSelectedAttributes.Items.Count - 1
   If lstSelectedAttributes.GetSelected(i) = True Then
    KeyAttributeSet.Add(i)
   End If
  Next
  Dim LinClosureObject As New LinClosure
  Dim RHS As ArrayList = LinClosureObject.ComputeLinClosure(UniversalAttributeSet, KeyAttributeSet, FDSet)
  ' Find Results
  If RHS.Count < UniversalAttributeSet.Count Then
   ' Find and report missing attributes
   Dim FoundAttributes(UniversalAttributeSet.Count - 1) As Boolean
   For i As Integer = 0 To FoundAttributes.Length - 1
    FoundAttributes(i) = False
   Next
   For Each RHSItem As Integer In RHS
    FoundAttributes(RHSItem) = True
   Next
   Dim MissingAttributeString As String = ""
   For i As Integer = 0 To FoundAttributes.Length - 1
    If FoundAttributes(i) = False Then
     MissingAttributeString = MissingAttributeString + UniversalAttributeSet(i)
    End If
   Next
   txtResults.Text = "Selected attribute set is not a key. Does not determine the following attributes:" + vbCrLf + MissingAttributeString
   txtResults.Refresh()
  Else
   ' This is a key - test to see if it's a superkey.
   Dim SuperKeyAttributes As String = ""
   For TestAttribute As Integer = 0 To KeyAttributeSet.Count - 1
    Dim SubKeyAttributeSet As New ArrayList
    For i As Integer = 0 To KeyAttributeSet.Count - 1
     If i <> TestAttribute Then
      SubKeyAttributeSet.Add(KeyAttributeSet(i))
     End If
    Next
    Dim SubKeyRHS As ArrayList = LinClosureObject.ComputeLinClosure(UniversalAttributeSet, SubKeyAttributeSet, FDSet)
    If SubKeyRHS.Count = RHS.Count Then
     Dim Index As Integer = KeyAttributeSet(TestAttribute)
     SuperKeyAttributes = SuperKeyAttributes + UniversalAttributeSet(Index) + " "
    End If
   Next

   If SuperKeyAttributes.Length = 0 Then
    txtResults.Text = "Selected attribute set is a key."
   Else
    txtResults.Text = "Selected attribute set is a superkey. Unnecessary attributes: " + SuperKeyAttributes
   End If
   txtResults.Refresh()
  End If
 End Sub
 Private Sub TestAttributeSetAsKey_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  Location = New Point(x, y)
  For Each Attribute As String In UniversalAttributeSet
   lstSelectedAttributes.Items.Add(Attribute)
  Next
  ' Fill known attribute set list
  Dim BasePath As String = System.Reflection.Assembly.GetExecutingAssembly().Location
  BasePath = BasePath.Substring(0, BasePath.Length - 37)
  Dim DirectoryPath As String = BasePath + "$AN"
  If System.IO.File.Exists(DirectoryPath) Then
   Dim input As New System.IO.StreamReader(DirectoryPath)
   Dim fullinput As String = input.ReadToEnd()
   input.Close()
   Dim filenames As String() = fullinput.Split(vbCrLf)
   lstAttributeSets.BeginUpdate()
   lstAttributeSets.Items.Clear()
   For Each filename As String In filenames
    Dim trimmedfilename As String = filename.Trim()
    If trimmedfilename.Length > 0 And System.IO.File.Exists(BasePath + "$A_" + trimmedfilename) Then
     lstAttributeSets.Items.Add(trimmedfilename)
    End If
   Next
   lstAttributeSets.EndUpdate()
   lstAttributeSets.Refresh()
  End If
 End Sub

 Private Sub lstAttributeSets_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstAttributeSets.DoubleClick
  If lstAttributeSets.SelectedIndex <> -1 Then
   Dim BasePath As String = System.Reflection.Assembly.GetExecutingAssembly().Location
   BasePath = BasePath.Substring(0, BasePath.Length - 37)
   Dim SelectedFilename As String = BasePath + "$A_" + lstAttributeSets.Items(lstAttributeSets.SelectedIndex)
   If System.IO.File.Exists(SelectedFilename) Then
    Dim s As New System.IO.StreamReader(SelectedFilename)
    Dim input As String = s.ReadToEnd()
    s.Close()
    Dim inputstrings As String() = input.Split(vbCrLf)
    ' Parse all attributes in selected attribute set file
    Dim UnknownAttributes As String = ""
    Dim SelectedAttributes As New ArrayList
    For Each Attribute As String In inputstrings
     Dim TrimmedAttribute As String = Attribute.Trim()
     If TrimmedAttribute.Length > 0 Then
      Dim Found As Boolean = False
      For AttributeIndex As Integer = 0 To UniversalAttributeSet.Count - 1
       If UniversalAttributeSet(AttributeIndex) = TrimmedAttribute Then
        SelectedAttributes.Add(AttributeIndex)
        Found = True
       End If
      Next
      If Found = False Then
       UnknownAttributes = UnknownAttributes + TrimmedAttribute + " "
      End If
     End If
    Next
    If UnknownAttributes.Length > 0 Then
     MessageBox.Show("Error: Unknown attributes in selected attribute set: " + UnknownAttributes, "Error Loading Attribute Set", MessageBoxButtons.OK, MessageBoxIcon.Error)
    Else ' Valid attribute set - select all known icons
     lstSelectedAttributes.BeginUpdate()
     For i As Integer = 0 To lstSelectedAttributes.Items.Count - 1
      lstSelectedAttributes.SetSelected(i, False)
     Next
     For Each i As Integer In SelectedAttributes
      lstSelectedAttributes.SetSelected(i, True)
     Next
     lstSelectedAttributes.EndUpdate()
     lstSelectedAttributes.Refresh()
    End If
   End If
  End If
 End Sub

#End Region

End Class
